/*
 Comparamos dúas cadeas terminadas en 0

*/
      .data
cad1: .asciz "Ola Mundo!"
cad2: .asciz "Ola Mundo!"
res:  .space 1

      .text
main: ldr     r5, =cad1      @ direccións das cadeas
      ldr     r6, =cad2
      mov     r7, #0xff      @ supomos que son distintas

      mov     r0, r5
      bl      tamc           @ calculamos o tamaño da primeira
      mov     r4, r0

      mov     r0,r6
      bl      tamc           @ e o da segunda
      mov     r3, r0

      cmp     r3, r4
      bne     fin            @ se os tamaños son diferentes
                             @ as cadeas non poden ser iguais
      mov     r0, r5
      mov     r1, r6
      bl      eqc            @ vemos se son iguais
      mov     r7, r0         @ recuperamos o resultado

fin:  ldr     r1, =res
      strb    r7, [r1]       @ almacenamos o resultado
      wfi

@ 
@ subrutina de cálculo do tamaño dunha cadea de caracteres 
@ terminada en 0
@
@      entrada: en r0: dir. de comezo da cadea (1 word)
@      saída:  en r0: tamaño (1 word)
@
tamc: 
      mov    r2, #0     @ contador a cero
buctc:      
      ldrb   r1, [r0]   @ cargamos byte de primeira cadea
      cmp    r1, #0     @ vemos se terminamos
      beq    tcd                  
      add    r2, r2, #1 @ incrementamos contador
      add    r0, r0, #1 @ incrementamos o punteiro
      b      buctc

tcd:  mov    r0, r2     @ almacenamos o resultado
      mov    pc,lr      @ volvemos
@
@ subrutina que determina se dúas cadeas terminadas en 0 da mesma 
@ lonxitude son iguais
@
@      entrada: r0, r1: direccións de comezo das cadeas
@      saída:  r0: 0x00000000 = son iguais, 0x000000ff son 
@               diferentes.
@
eqc:  ldrb   r2, [r0]      @ cargamos un carácter
      cmp    r2, #0        @ se chegamos ao final
      beq    fieqc         @ é que son iguais
      ldrb   r3, [r1]      @ cargamos un da outra cadea
      cmp    r2, r3        @ comparámolos
      bne    disteqc       @ se non, cadeas distintas
      add    r0, r0, #1    @ actualizamos punteiros
      add    r1, r1, #1
      b      eqc           @ outro carácter

fieqc:      
      mov    r0, #0x00     @ son iguais
      mov    pc,lr

disteqc:                   @ son diferentes
      mov    r0, #0xff
      mov    pc, lr
      .end
